## cub 1.9.8

=== debian/changelog ===
cub (1.9.8-1) unstable; urgency=medium

  * Initial release.
  * CUB is now released independently from thrust.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 29 Jul 2020 02:25:02 +0200
