=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# the cmake build system for examples and tests assumes CUDA availability
override_dh_auto_configure override_dh_auto_build override_dh_auto_test override_dh_auto_install override_dh_auto_clean:

override_dh_installchangelogs:
	dh_installchangelogs CHANGE_LOG.TXT

override_dh_installexamples:
	dh_installexamples -X.gitignore
