## cub 1.9.10-1

=== debian/changelog ===
cub (1.9.10-1-1) unstable; urgency=medium

  * New upstream release 1.9.10-1 (CUDA 11.1).

 -- Andreas Beckmann <anbe@debian.org>  Mon, 10 Aug 2020 21:55:36 +0200
