=== debian/control ===
Source: cub
Section: libdevel
Priority: optional
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <anbe@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://github.com/thrust/cub
Vcs-Browser: https://salsa.debian.org/nvidia-team/cub
Vcs-Git: https://salsa.debian.org/nvidia-team/cub.git

Package: libcub-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: reusable software components for the CUDA programming model
 CUB provides state-of-the-art, reusable software components for every layer
 of the CUDA programming model:
 * Parallel primitives
   * Warp-wide "collective" primitives
   * Block-wide "collective" primitives
   * Device-wide primitives
 * Utilities
   * Fancy iterators
   * Thread and thread block I/O
   * PTX intrinsics
   * Device, kernel, and storage management
