=== debian/watch ===
version=3

https://github.com/thrust/cub/releases .*/(\d+.*)\.tar\.gz
