## cub 1.11.0

=== debian/changelog ===
cub (1.11.0-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 02 Feb 2021 20:08:08 +0100

cub (1.11.0-1) unstable; urgency=medium

  * New upstream release 1.11.0.
  * New upstream release 1.10.0 (CUDA 11.2).
  * Update upstream location.
  * Bump Standards-Version to 4.5.1, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 08 Jan 2021 14:50:26 +0100

cub (1.9.10-1-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 23 Aug 2020 01:28:57 +0200
