=== debian/control ===
--- 
+++ 
@@ -7,8 +7,8 @@
 Build-Depends:
  debhelper-compat (= 13),
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
-Homepage: https://github.com/thrust/cub
+Standards-Version: 4.5.1
+Homepage: https://github.com/NVIDIA/cub
 Vcs-Browser: https://salsa.debian.org/nvidia-team/cub
 Vcs-Git: https://salsa.debian.org/nvidia-team/cub.git
