=== debian/watch ===
version=4

https://github.com/NVIDIA/cub/releases .*/(\d+.*)\.tar\.gz
