## cub 1.15.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
-# Will be increased to 3.18 when C++17 is enabled:
+# 3.15 is the minimum.
+# 3.17 for NVC++.
+# 3.18.3 for C++17 + CUDA.
 cmake_minimum_required(VERSION 3.15)
 
 # Remove this when we use the new CUDA_ARCHITECTURES properties.
@@ -7,7 +9,7 @@
 endif()
 
 # CXX is only needed for AppendOptionIfAvailable.
-project(CUB)
+project(CUB NONE)
 
 # Determine whether CUB is the top-level project or included into
 # another project via add_subdirectory().
@@ -48,7 +50,28 @@
 
 option(CUB_ENABLE_HEADER_TESTING "Test that all public headers compile." ON)
 option(CUB_ENABLE_TESTING "Build CUB testing suite." ON)
+option(CUB_ENABLE_THOROUGH_TESTING "Build CUB thorough test variants." ON)
+option(CUB_ENABLE_BENCHMARK_TESTING  "Build CUB benchmark test variants." ON)
+option(CUB_ENABLE_MINIMAL_TESTING "Build CUB minimal test variants." ON)
 option(CUB_ENABLE_EXAMPLES "Build CUB examples." ON)
+# This is needed for NVCXX QA, which requires a static set of executable names.
+# Only a single dialect may be enabled when this is off.
+option(CUB_ENABLE_CPP_DIALECT_IN_NAMES
+  "Include C++ dialect information in target/object/etc names."
+  ON
+)
+mark_as_advanced(CUB_ENABLE_CPP_DIALECT_IN_NAMES)
+
+# By default, suppress deprecation warnings when building our test suite,
+# since we'll need to test deprecated APIs with `-Werror`. This option is only
+# used when CUB is built stand-alone; otherwise the Thrust option has the same
+# effect.
+if (NOT CUB_IN_THRUST)
+  option(CUB_IGNORE_DEPRECATED_API
+    "Suppress warnings about deprecated Thrust/CUB API."
+    ON
+  )
+endif()
 
 # Check if we're actually building anything before continuing. If not, no need
 # to search for deps, etc. This is a common approach for packagers that just
@@ -63,6 +86,7 @@
 include(cmake/CubBuildCompilerTargets.cmake)
 include(cmake/CubBuildTargetList.cmake)
 include(cmake/CubCudaConfig.cmake)
+include(cmake/CubUtilities.cmake)
 
 if ("" STREQUAL "${CMAKE_BUILD_TYPE}")
   set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose the type of build." FORCE)
