=== debian/changelog ===
cub (1.15.0-3) unstable; urgency=medium

  * Tune autopkgtests.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 12 Mar 2022 02:23:11 +0100

cub (1.15.0-2) unstable; urgency=medium

  * Use upstream build system for installation.
  * Add superficial autopkgtest for cmake find_package(CUB).
  * Add superficial autopkgtest compiling the upstream testsuite for C++14
    and C++17 (requires nvidia-cuda-toolkit/non-free).
    (Running the testsuite would require a CUDA capable CPU and using the
    kernel module from nvidia-graphics-drivers/non-free.)
    Currently this only works with g++-10 while g++-11 fails with spurious
    errors.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 23 Feb 2022 10:54:36 +0100

cub (1.15.0-1) unstable; urgency=medium

  * New upstream release 1.15.0 (CUDA 11.6).

 -- Andreas Beckmann <anbe@debian.org>  Thu, 10 Feb 2022 17:03:21 +0100
