=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
  Andreas Beckmann <anbe@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
+ cmake,
 Rules-Requires-Root: no
 Standards-Version: 4.6.0
 Homepage: https://github.com/NVIDIA/cub
@@ -16,6 +17,8 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}
+Breaks:
+ libthrust-dev (<< 1.15.0),
 Description: reusable software components for the CUDA programming model
  CUB provides state-of-the-art, reusable software components for every layer
  of the CUDA programming model:
