## cub 1.16.0

=== debian/changelog ===
cub (1.16.0-2) unstable; urgency=medium

  * Update watch file.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 11 Nov 2022 12:05:01 +0100

cub (1.16.0-1) unstable; urgency=medium

  * New upstream release 1.16.0.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 18 Jun 2022 15:14:27 +0200

cub (1.15.0-4) unstable; urgency=medium

  * Generate debian/tests/control from debian/tests/control.sh.
  * Reduce amount of autopkgtest tests.
  * Add salsa-ci.yml.
  * Bump Standards-Version to 4.6.1, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 03 Jun 2022 15:29:58 +0200
