=== debian/rules ===
--- 
+++ 
@@ -15,8 +15,15 @@
 	dh_auto_install --destdir=debian/tmp
 
 execute_after_dh_auto_install:
+	$(RM) -v debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/cub/cub-header-search.cmake.in
 	# remove empty directories
 	find debian/tmp -depth -type d -exec sh -c 'd="{}"; rmdir --ignore-fail-on-non-empty "$$d" ; test -d "$$d" || echo "removed $$d"' \;
 
 override_dh_installexamples:
 	dh_installexamples -X.gitignore
+
+
+debian/tests/control: debian/tests/control.sh
+	sh $< > $@
+
+clean: debian/tests/control
