## cub 1.17.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -50,9 +50,6 @@
 
 option(CUB_ENABLE_HEADER_TESTING "Test that all public headers compile." ON)
 option(CUB_ENABLE_TESTING "Build CUB testing suite." ON)
-option(CUB_ENABLE_THOROUGH_TESTING "Build CUB thorough test variants." ON)
-option(CUB_ENABLE_BENCHMARK_TESTING  "Build CUB benchmark test variants." ON)
-option(CUB_ENABLE_MINIMAL_TESTING "Build CUB minimal test variants." ON)
 option(CUB_ENABLE_EXAMPLES "Build CUB examples." ON)
 # This is needed for NVCXX QA, which requires a static set of executable names.
 # Only a single dialect may be enabled when this is off.
@@ -62,14 +59,12 @@
 )
 mark_as_advanced(CUB_ENABLE_CPP_DIALECT_IN_NAMES)
 
-# By default, suppress deprecation warnings when building our test suite,
-# since we'll need to test deprecated APIs with `-Werror`. This option is only
-# used when CUB is built stand-alone; otherwise the Thrust option has the same
-# effect.
+# This option is only used when CUB is built stand-alone; otherwise the Thrust
+# option has the same effect.
 if (NOT CUB_IN_THRUST)
   option(CUB_IGNORE_DEPRECATED_API
     "Suppress warnings about deprecated Thrust/CUB API."
-    ON
+    OFF
   )
 endif()
