=== debian/changelog ===
cub (1.17.2-2) unstable; urgency=medium

  * Stop testing with g++-10.
  * Bump Standards-Version to 4.6.2, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 21 Feb 2023 10:51:10 +0100

cub (1.17.2-1) unstable; urgency=medium

  * New upstream release 1.17.2.
  * Install *.cmake to CMAKE_INSTALL_DATADIR.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 23 Dec 2022 20:55:22 +0100
