=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  debhelper-compat (= 13),
  cmake,
 Rules-Requires-Root: no
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/NVIDIA/cub
 Vcs-Browser: https://salsa.debian.org/nvidia-team/cub
 Vcs-Git: https://salsa.debian.org/nvidia-team/cub.git
