=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,11 @@
+# Some tests always build with RDC, so make sure that the sm_XX flags are
+# compatible. See note in CubCudaConfig.cmake.
+# TODO once we're using CUDA_ARCHITECTURES, we can setup non-rdc fallback
+# tests to build for non-rdc arches. But for now, all files in a given directory
+# must build with the same `CMAKE_CUDA_FLAGS` due to CMake constraints around
+# how CUDA_FLAGS works.
+set(CMAKE_CUDA_FLAGS "${CUB_CUDA_FLAGS_BASE} ${CUB_CUDA_FLAGS_RDC}")
+
 # The function below reads the filepath `src`, extracts the %PARAM% comments,
 # and fills `labels_var` with a list of `label1_value1.label2_value2...`
 # strings, and puts the corresponding `DEFINITION=value1:DEFINITION=value2`
@@ -23,6 +31,7 @@
       unused
       "${match}"
     )
+
     set(def ${CMAKE_MATCH_1})
     set(label ${CMAKE_MATCH_2})
     set(values "${CMAKE_MATCH_3}")
@@ -57,7 +66,6 @@
       endforeach()
       set(variant_defs "${tmp_defs}")
     endif()
-
   endforeach()
 
   set(${labels_var} "${variant_labels}" PARENT_SCOPE)
@@ -105,6 +113,7 @@
   target_link_libraries(${test_target} ${cub_target})
   cub_clone_target_properties(${test_target} ${cub_target})
   target_include_directories(${test_target} PRIVATE "${CUB_SOURCE_DIR}/test")
+  target_compile_definitions(${test_target} PRIVATE CUB_DEBUG_HOST_ASSERTIONS)
 
   # Add to the active configuration's meta target
   add_dependencies(${config_meta_target} ${test_target})
@@ -115,15 +124,33 @@
   endif()
   add_dependencies(${test_meta_target} ${test_target})
 
-  if (CUB_ENABLE_TESTS_WITH_RDC)
-    cub_enable_rdc_for_cuda_target(${test_target})
-  endif()
-
   add_test(NAME ${test_target}
     COMMAND "$<TARGET_FILE:${test_target}>"
   )
 endfunction()
 
+# Sets out_var to 1 if the label contains cdp variants, regardless of whether
+# or not CDP is enabled in this particular variant.
+function(_cub_has_cdp_variant out_var label)
+  string(FIND "${label}" "cdp_" idx)
+  if (idx EQUAL -1)
+    set(${out_var} 0 PARENT_SCOPE)
+  else()
+    set(${out_var} 1 PARENT_SCOPE)
+  endif()
+endfunction()
+
+# Sets out_var to 1 if the label contains "cdp_1", e.g. cdp is explicitly
+# requested for this variant.
+function(_cub_is_cdp_enabled_variant out_var label)
+  string(FIND "${label}" "cdp_1" idx)
+  if (idx EQUAL -1)
+    set(${out_var} 0 PARENT_SCOPE)
+  else()
+    set(${out_var} 1 PARENT_SCOPE)
+  endif()
+endfunction()
+
 foreach (test_src IN LISTS test_srcs)
   get_filename_component(test_name "${test_src}" NAME_WE)
   string(REGEX REPLACE "^test_" "" test_name "${test_name}")
@@ -135,7 +162,7 @@
   math(EXPR range_end "${num_variants} - 1")
 
   # Verbose output:
-  if (NOT num_variants EQUAL 0)
+  if (num_variants GREATER 0)
     message(VERBOSE "Detected ${num_variants} variants of test '${test_src}':")
     foreach(var_idx RANGE ${range_end})
       math(EXPR i "${var_idx} + 1")
@@ -151,11 +178,16 @@
     if (num_variants EQUAL 0)
       # Only one version of this test.
       cub_add_test(test_target ${test_name} "${test_src}" ${cub_target})
-    else()
+      if (CUB_ENABLE_TESTS_WITH_RDC)
+        cub_enable_rdc_for_cuda_target(${test_target})
+      endif()
+    else() # has variants:
       # Meta target to build all parametrizations of the current test for the
       # current CUB_TARGET config
       set(variant_meta_target ${config_prefix}.test.${test_name}.all)
-      add_custom_target(${variant_meta_target})
+      if (NOT TARGET ${variant_meta_target})
+        add_custom_target(${variant_meta_target})
+      endif()
 
       # Meta target to build all parametrizations of the current test for all
       # CUB_TARGET configs
@@ -170,6 +202,10 @@
         list(GET variant_labels ${var_idx} label)
         list(GET variant_defs ${var_idx} defs)
         string(REPLACE ":" ";" defs "${defs}")
+
+        # Check if the test has explicit CDP variants:
+        _cub_has_cdp_variant(explicit_cdp "${label}")
+        _cub_is_cdp_enabled_variant(enable_cdp "${label}")
 
         cub_add_test(test_target
           ${test_name}.${label}
@@ -179,9 +215,20 @@
         add_dependencies(${variant_meta_target} ${test_target})
         add_dependencies(${cub_variant_meta_target} ${test_target})
         target_compile_definitions(${test_target} PRIVATE ${defs})
-      endforeach()
-    endif()
-  endforeach()
-endforeach()
+
+        # Enable RDC if the test either:
+        # 1. Explicitly requests it (cdp_1 label)
+        # 2. Does not have an explicit CDP variant (no cdp_0 or cdp_1) but
+        #    RDC testing is globally enabled.
+        #
+        # Tests that explicitly request no cdp (cdp_0 label) should never enable
+        # RDC.
+        if (enable_cdp OR ((NOT explicit_cdp) AND CUB_ENABLE_TESTS_WITH_RDC))
+          cub_enable_rdc_for_cuda_target(${test_target})
+        endif()
+      endforeach() # Variant
+    endif() # Has variants
+  endforeach() # CUB targets
+endforeach() # Source file
 
 add_subdirectory(cmake)
