=== debian/changelog ===
cub (2.0.1-2) unstable; urgency=medium

  * Add Depends: libcu++-dev (>= 1.8.0).
  * Fix autopkgtests with older nvcc.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 15 Jun 2023 09:50:17 +0200

cub (2.0.1-1) experimental; urgency=medium

  * New upstream release 2.0.1.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 22 Feb 2023 11:17:46 +0100
