=== debian/control ===
--- 
+++ 
@@ -16,7 +16,9 @@
 Package: libcub-dev
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}
+Depends:
+ libcu++-dev (>= 1.8.0),
+ ${misc:Depends}
 Breaks:
  libthrust-dev (<< 1.15.0),
 Description: reusable software components for the CUDA programming model
