=== debian/tests/control ===
--- 
+++ 
@@ -17,6 +17,7 @@
  nvidia-cuda-toolkit-gcc,
 Restrictions:
  superficial,
+ allow-stderr,
  flaky,
 
 Test-Command: debian/tests/compile-cub-tests cuda-g++ 14
@@ -29,6 +30,7 @@
  nvidia-cuda-toolkit-gcc,
 Restrictions:
  superficial,
+ allow-stderr,
  flaky,
 
 Test-Command: debian/tests/compile-cub-tests g++-11 17
@@ -42,6 +44,7 @@
  nvidia-cuda-toolkit-gcc,
 Restrictions:
  superficial,
+ allow-stderr,
  flaky,
  skippable,
