## cub 2.1.0

=== debian/changelog ===
cub (2.1.0-1) unstable; urgency=medium

  * New upstream release 2.1.0.
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 25 Jun 2024 18:32:02 +0200
